version: '3'
services:
  db:
    restart: always
    image: postgres:14-alpine
    shm_size: 256mb
    networks:
      - internal_network
    volumes:
      - /srv/mastodon/postgres14:/var/lib/postgresql/data
    # added from the default, otherwise you'll need to manually create a `mastodon` db and user/role
    env_file: db.env  
    environment:
      - 'POSTGRES_HOST_AUTH_METHOD=trust'

  redis:
    restart: always
    image: redis:7-alpine
    networks:
      - internal_network
    env_file: db.env  
    healthcheck:
      test: ['CMD', 'redis-cli', 'ping']
    volumes:
      - /srv/mastodon/redis:/data

  web:
    image: tootsuite/mastodon:v3.5.3
    restart: always
    env_file:
      - .env
      - db.env
    command: bash -c "rm -f /mastodon/tmp/pids/server.pid; bundle exec rails s -p 3000"
    networks:
      - traefik
      - internal_network
    healthcheck:
      # prettier-ignore
      test: ['CMD-SHELL', 'wget -q --spider --proxy=off localhost:3000/health || exit 1']
    depends_on:
      - db
      - redis
    volumes:
      - /srv/mastodon/web:/mastodon/public/system
    labels:
      - traefik.enable=true
      - traefik.http.routers.mastodonweb.rule=Host(`mastodon.$DOMAIN_NAME`)
      - traefik.http.routers.mastodonweb.entrypoints=websecure
      - traefik.http.routers.mastodonweb.tls.certresolver=letsencr
      - traefik.http.services.mastodonweb.loadbalancer.server.port=3000

  streaming:
    image: tootsuite/mastodon:v3.5.3
    restart: always
    env_file:
      - .env
      - db.env
    command: node ./streaming
    networks:
      - traefik
      - internal_network
    healthcheck:
      # prettier-ignore
      test: ['CMD-SHELL', 'wget -q --spider --proxy=off localhost:4000/api/v1/streaming/health || exit 1']
    depends_on:
      - db
      - redis
    labels:
      - traefik.enable=true
      - traefik.http.routers.mastodonstreaming.rule=(Host(`mastodon.$DOMAIN_NAME`) && PathPrefix(`/api/v1/streaming`))
      - traefik.http.routers.mastodonstreaming.entrypoints=websecure
      - traefik.http.routers.mastodonstreaming.tls.certresolver=letsencr
      - traefik.http.services.mastodonstreaming.loadbalancer.server.port=4000


  sidekiq:
    image: tootsuite/mastodon:v3.5.3
    restart: always
    env_file:
      - .env
      - db.env
    command: bundle exec sidekiq
    depends_on:
      - db
      - redis
    networks:
      - traefik
      - internal_network
    volumes:
      - /srv/mastodon/sidekiq:/mastodon/public/system
    healthcheck:
      test: ['CMD-SHELL', "ps aux | grep '[s]idekiq\ 6' || false"]


networks:
  traefik:
    external: true
  internal_network:
    internal: true